      program ppot   
      implicit none
c cart coords
      real*8 ,allocatable ::xyz (:,:)
c grad      
      real*8 ,allocatable ::g   (:,:)
      real*8 ,allocatable ::g1  (:,:)
      real*8 ,allocatable ::g2  (:,:)
      real*8 ,allocatable ::g3  (:,:)
      real*8 ,allocatable ::g4  (:,:)
c atomic ordinal number
      integer,allocatable ::at  (:)
c # atoms
      integer n
c # logical if tm files are written
      logical tmgrad      
c energy 
      real*8 edisp,egcp,ebas,eat,etot      
c D3 parameter
      real*8 rs6,s18,rs18      
c conversion factor
      real*8 autokcal 
      parameter (autokcal=627.509541d0)
c for D3 (H-Pu)       
      integer max_elem
      parameter (max_elem=94)
c pbex hybrid ?
      logical pbex

c local stuff
      character*80 fname      
      character*128 atmp,btmp       
      character*2 asym              
      integer i
      logical ex
 
      tmgrad=.false.
      pbex  =.false.

      write(*,'(9x,''+--------------------------------------------+'')')
      write(*,'(9x,''|             P P O T  (SG, Mar 12)          |'')')
      write(*,'(9x,''|   corrects for D3, BSSE by gcp and basis   |'')')
      write(*,'(9x,''+--------------------------------------------+'')')
      write(*,*)'please cite'
      write(*,'(9x,''a) DFT-D3:'')')
      write(*,*)'S. Grimme, J. Antony, S. Ehrlich and H. Krieg,'
      write(*,*)'J. Chem. Phys. 132 (2010), 154104'
      write(*,*)'S. Grimme, S. Ehrlich and L. Goerigk,'
      write(*,*)'J. Comput. Chem. 32 (2011), 1456-1465'
      write(*,'(9x,''b) gCP:'')')
      write(*,*)'H. Kruse and S. Grimme,'
      write(*,*)'J. Chem. Phys. 134 (2012), 154101.'
      write(*,'(9x,''c) SRB correction (HF-3c):'')')
      write(*,*)'R. Sure and S. Grimme,'
      write(*,*)'J. Comput. Chem., 34 (2013), 1672.'

      call getarg(2,atmp)
c modify $energy & $gradient      
      if(index(atmp,'-tmgrad' ).ne.0)   tmgrad=.true.

      inquire(file='.PPOT_inp',exist=ex)
      if(ex)then
      open(unit=1,file='.PPOT_inp')
      read(1,'(a)',end=11)atmp
      if(index(atmp,'pbex' ).ne.0) pbex  =.true.
  11  close(1)
      endif

      call getarg(1,fname)
      inquire(file=fname,exist=ex)
      if(.not.ex) call stoprun('file does not exist!')

c how many atoms?
      call rd0(fname,n)
      allocate(xyz(3,n),at(n),g(3,n)) 
      allocate(g1(3,n),g2(3,n),g3(3,n),g4(3,n)) 

c read coord in TM format
      call rd(fname,n,xyz,at)
 
c print
      write(*,*)
      write(*,*)'coordinates (Bohr)'
      do i=1,n
         write(*,'(i4,2x,a2,3x,3f12.5)')i,asym(at(i)),xyz(1:3,i)
      enddo
      write(*,*)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3D3         
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      rs6 =0.4171  
      s18 =0.8777   
      rs18=2.9149  
      if(pbex)then
c pbe0/svx              
c     rs6=0.144
c     s18=0.701
c     rs18=5.431     
c pbe38/svx              
c     rs6=0.000
c     s18=0.708
c     rs18=6.270    
c pbe12/svx              
      rs6=0.000
      s18=2.570
      rs18=7.340    
      endif

      call dftd3(n,at,xyz,.true.,.true.,rs6,s18,rs18,edisp,g1)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c gCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCPgCP      
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      atmp='hf/minix'
      if(pbex)atmp='dft/svx'

      call gcp(n,at,xyz,.true.,atmp,egcp,g2)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c BASBASBASBASBASBASBASBASBASBASBASBASBASBASBASBASBASBASBASBAS
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      if(.not.pbex)then
      call basegrad(n,max_elem,at,xyz,0.7d0,0.03d0,ebas,g3)
      else
c     call basegrad(n,max_elem,at,xyz,1.0d0,0.100d0,ebas,g3)
      g3=0
      ebas=0
      endif
 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c     call spec(n,at,xyz,.true.,eat,g4)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      g=g1+g2+g3

      etot=edisp+egcp+ebas

      write(*,*)
      write(*,*)'======================================'
      write(*,*)'            FINAL RESULTS'
      write(*,*)'======================================'
      write(*,'('' Edisp  /kcal,au:'',f11.4,f12.8)')edisp*autokcal,edisp
      write(*,'('' Egcp   /kcal,au:'',f11.4,f12.8)')egcp *autokcal,egcp  
      write(*,'('' Ebas   /kcal,au:'',f11.4,f12.8)')ebas *autokcal,ebas 
c     write(*,'('' Eat    /kcal,au:'',f11.4,f12.8)')eat  *autokcal,eat  
      write(*,*)
      write(*,*)'|G|=',sum(abs(g(1:3,1:n)))
      write(*,*)
      write(*,'('' Etot  /kcal,au:'',f11.4,f12.8)')etot *autokcal,etot 

c write gradient for TM
      if(tmgrad)then
         call wregrad(n,at,xyz,etot,g)
      else   
         open(unit=1,file='.PPOT')
         write(1,*)etot
         close(1)     
         call outg('ppot_gradient',n,g)
      endif   

      end
